<?php
/* $Id: process.php,v 1.5 2007/05/11 11:13:55 iws Exp $ */

require_once("feedcreator.class.php");


/***********/
/* GLOBALS */
/***********/

// user configurable - move to config.php ?
$src_dir="upload";			// file path to the source images
$dest_dir="site";			// file path for the generated content
$site_name="My Great Photos";		// the ASCII string name of the site
$site_url="http://my.web.site";		// the URL (inc http://) for the site
$blog_url="";				// the URL (inc http://) of any associated blog
$site_tag="Brilliant images";		// the ASCII string tagline
$copyright="2007";			// the ASCII string copyright year(s)
$photographer="Me";			// the ASCII string for main credit
$about_text="";				// optional ASCII string instead of about.txt

$most_recent_count=12;			// how many images are shown at the top of the
					// archive page and in the RSS feed

/******************* NO NEED TO CHANGE ANYTHING BELOW HERE ******************/

// don't really 100% necessary, but handy as a reminder
$most_recent_five=Array();
$most_recent_images=Array();
$reverse_files_and_paths=Array();
$files_and_paths=Array();
$file_tree=Array();


/*************/
/* FUNCTIONS */
/*************/

// why a function and not a lookup array ?  this should hopefully allow
// easy translation to all languages that PHP is supported in...
function month_name($month_num) {
  return date("F", mktime(0,0,0,$month_num,1,2007));
}

// needs localisation
function date_ending($day) {
  if (($day == 1) || ($day == 21) || ($day == 31)) return("st");
  if (($day == 2) || ($day == 22))                 return("nd");
  if (($day == 3) || ($day == 23))                 return("rd");
  // only four endings to consider
  return("th");
}

function page_menu($fh) {
  global $site_name,$site_tag,$photographer,$copyright,$blog_url;

  fwrite($fh,'<div id="sidebar">'."\n");
  fwrite($fh,'<h1 id="page-title">'.$site_name.'</h1>'."\n");
  fwrite($fh,'<h2 id="tagline">'.$site_tag.'</h2>'."\n");
  fwrite($fh,'<div id="nav">'."\n");
  fwrite($fh,'<a href="/">Home</a>'."\n");
  fwrite($fh,'<a href="/archive.html">Archive</a>'."\n");
  fwrite($fh,'<a href="/about.html">About</a>'."\n");
  if (strlen($blog_url) > 0) {
    fwrite($fh,'<a href="'.$blog_url.'">Blog</a>'."\n");
  }
  fwrite($fh,'<a href="/rss2.xml">RSS</a>'."\n");
  fwrite($fh,"</div>\n");
  fwrite($fh,'<div id="badges">'."\n");
  fwrite($fh,'<a href="http://alder.minimal.cx/" id="powered-by-alder">Powered By Alder</a>'."\n");
  fwrite($fh,"</div>\n");
  fwrite($fh,'<div id="copyright">&copy; '.$copyright.' '.$photographer.'</div>'."\n");
  fwrite($fh,"</div>\n");
}

function page_header($fh) {
  global $site_name;

  fwrite($fh,'<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"'."\n");
  fwrite($fh,'"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd  ">'."\n");
  fwrite($fh,'<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">'."\n");
  fwrite($fh,"<head>\n");
  fwrite($fh,"<title>$site_name</title>\n");
  fwrite($fh,'<link rel="alternate" type="application/rss+xml" title="RSS 2.0" href="'.$site_url.'/rss2.xml" />'."\n");
  fwrite($fh,'<link rel="alternate" type="text/xml" title="RSS .92" href="'.$site_url.'/rss.xml" />'."\n");
  fwrite($fh,'<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />'."\n");
  fwrite($fh,'<meta name="author" content="" />'."\n");
  fwrite($fh,'<meta name="keywords" content="" />'."\n");
  fwrite($fh,'<meta name="description" content="" />'."\n");
  fwrite($fh,'<meta name="robots" content="index" />'."\n");
  fwrite($fh,'<link rel="stylesheet" type="text/css" href="/include/styles.css" />'."\n");
  fwrite($fh,"</head>\n");
  fwrite($fh,"<body>\n");
  fwrite($fh,'<div id="content">'."\n");
}

function page_footer($fh,$use_js=TRUE) {
  fwrite($fh,"</div>\n");
  if ($use_js) {
    fwrite($fh,'<script language="JavaScript" type="text/javascript" src="/include/wz_tooltip.js"></script>'."\n");
  }
  fwrite($fh,"</body>\n");
  fwrite($fh,"</html>\n");
}

function build_day_archive($fh,$year,$month,$day) {
  global $reverse_files_and_paths;

  fwrite($fh,'<div id="main">'."\n");
  fwrite($fh,'<div id="recent">'."\n");
  $timestamp=mktime(0,0,0,$month,$day,$year);
  $title=strftime("%A the%e".date_ending((int)$day)." of %B, %Y",$timestamp);
  fwrite($fh,"<h3>Photos from $title</h3>\n");
  $i=0;
  $found_it=FALSE;
  while ($i<count($reverse_files_and_paths)) {
    $the_year=substr($reverse_files_and_paths[$i]['path'],0,4);
    $the_month=substr($reverse_files_and_paths[$i]['path'],5,2);
    $the_day=substr($reverse_files_and_paths[$i]['path'],8,2);
    if (($the_year == $year) && ($the_month == $month) && ($the_day == $day)) {
      $found_it=TRUE;
      fwrite($fh,'<a href="/'.$reverse_files_and_paths[$i]['path'].'/'.basename($reverse_files_and_paths[$i]['file'],".jpg").'.html"><img src="/'.$reverse_files_and_paths[$i]['path'].'/thumb_'.$reverse_files_and_paths[$i]['file'].'" '.thumb_size($reverse_files_and_paths[$i]).' '.$reverse_files_and_paths[$i]['class'].' alt="" /></a>'."\n");
    } else {
      if ($found_it == TRUE) $i=count($reverse_files_and_paths);
    }
    $i++;
  }
  fwrite($fh,"</div>\n");
  fwrite($fh,"</div>\n");
}

function build_month_archive($fh,$year,$month) {
  global $reverse_files_and_paths;

  fwrite($fh,'<div id="main">'."\n");
  fwrite($fh,'<div id="recent">'."\n");
  fwrite($fh,"<h3>Photos from ".month_name($month).", $year</h3>\n");
  $i=0;
  $found_it=FALSE;
  while ($i<count($reverse_files_and_paths)) {
    $the_year=substr($reverse_files_and_paths[$i]['path'],0,4);
    $the_month=substr($reverse_files_and_paths[$i]['path'],5,2);
    if (($the_year == $year) && ($the_month == $month)) {
      $found_it=TRUE;
      fwrite($fh,'<a href="/'.$reverse_files_and_paths[$i]['path'].'/'.basename($reverse_files_and_paths[$i]['file'],".jpg").'.html"><img src="/'.$reverse_files_and_paths[$i]['path'].'/thumb_'.$reverse_files_and_paths[$i]['file'].'" '.thumb_size($reverse_files_and_paths[$i]).' '.$reverse_files_and_paths[$i]['class'].' alt="" /></a>'."\n");
    } else {
      if ($found_it == TRUE) $i=count($reverse_files_and_paths);
    }
    $i++;
  }
  fwrite($fh,"</div>\n");
  fwrite($fh,"</div>\n");
}

function build_year_archive($fh,$year) {
  global $reverse_files_and_paths,$most_recent_count;

  fwrite($fh,'<div id="main">'."\n");
  fwrite($fh,'<div id="recent">'."\n");
  fwrite($fh,"<h3>Photos from $year</h3>\n");
  $i=0;
  $summary_count=0;
  $found_it=FALSE;
  $thumbing=FALSE;
  $ul_open=FALSE;
  $li_open=FALSE;
  $last_month_shown=0;
  while ($i<count($reverse_files_and_paths)) {
    $the_year=substr($reverse_files_and_paths[$i]['path'],0,4);
    $the_month=substr($reverse_files_and_paths[$i]['path'],5,2);
    if ($the_year == $year) {
      $found_it=TRUE;
      if ($summary_count < $most_recent_count) {
        fwrite($fh,'<a href="/'.$reverse_files_and_paths[$i]['path'].'/'.basename($reverse_files_and_paths[$i]['file'],".jpg").'.html"><img src="/'.$reverse_files_and_paths[$i]['path'].'/thumb_'.$reverse_files_and_paths[$i]['file'].'" '.thumb_size($reverse_files_and_paths[$i]).' '.$reverse_files_and_paths[$i]['class'].' alt="" /></a>'."\n");
        $summary_count++;
      } else {
        if (!$thumbing) {
          fwrite($fh,'<div id="dates">'."\n");
          $thumbing=TRUE;
        }
        if ($last_month_shown != $the_month) {
          if ($li_open) fwrite($fh,"</li>\n");
          if ($ul_open) fwrite($fh,"</ul>\n");
          //fwrite($fh,"<h4>".month_name($the_month)."</h4>\n<ul>\n");
          $last_month_shown=$the_month;
          fwrite($fh,'<li><a href="/'.$the_year.'/'.$the_month.'/">'.month_name($the_month).'</a>');
          $li_open=TRUE;
          $ul_open=TRUE;
        }
        fwrite($fh,"<span></span>");
      }
    } else {
      if ($found_it == TRUE) $i=count($reverse_files_and_paths);
    }
    $i++;
  }
  if ($li_open) fwrite($fh,"</li>\n");
  if ($ul_open) fwrite($fh,"</ul>\n");
  if ($thumbing) fwrite($fh,"</div>\n");
  fwrite($fh,"</div>\n");
  fwrite($fh,"</div>\n");
}

function build_main_archive($fh) {
  global $most_recent_images,$reverse_files_and_paths,$most_recent_count;

  fwrite($fh,'<div id="main">'."\n");
  fwrite($fh,'<div id="recent">'."\n");
  fwrite($fh,"<h3>Recent Photos</h3>\n");
  for ($i=0; $i<count($most_recent_images); $i++) {
    fwrite($fh,'<a href="/'.$most_recent_images[$i]['path'].'/'.basename($most_recent_images[$i]['file'],".jpg").'.html"><img src="/'.$most_recent_images[$i]['path'].'/thumb_'.$most_recent_images[$i]['file'].'" '.thumb_size($most_recent_images[$i]).' '.$most_recent_images[$i]['class'].' alt="" /></a>'."\n");
  }
  fwrite($fh,"</div>\n");

  if (count($reverse_files_and_paths) > 11) {
    fwrite($fh,'<div id="dates">'."\n");
    fwrite($fh,"<h3>Older Photos</h3>\n");
    $last_year_shown=0;
    $last_month_shown=0;
    $ul_open=FALSE;
    $li_open=FALSE;
    for ($i=$most_recent_count; $i<count($reverse_files_and_paths); $i++) {
      $the_year=substr($reverse_files_and_paths[$i]['path'],0,4);
      $the_month=substr($reverse_files_and_paths[$i]['path'],5,2);
      if ($the_year != $last_year_shown) {
        if ($li_open) fwrite($fh,"</li>\n");
        if ($ul_open) fwrite($fh,"</ul>\n");
        fwrite($fh,"<h4>$the_year</h4>\n<ul>\n");
        $last_year_shown=$the_year;
        $last_month_shown=0;
        $ul_open=TRUE;
      }
      if ($the_month != $last_month_shown) {
        if ($li_open) fwrite($fh,"</li>\n");
        $last_month_shown=$the_month;
        fwrite($fh,'<li><a href="/'.$the_year.'/'.$the_month.'/">'.month_name($the_month).'</a>');
        $li_open=TRUE;
      }
      fwrite($fh,"<span></span>");
    }
    if ($li_open) fwrite($fh,"</li>\n");
    if ($ul_open) fwrite($fh,"</ul>\n");
    fwrite($fh,"</div>\n");
  }
  fwrite($fh,"</div>\n");
}

function get_current_files($directory) {
  $files=Array();
  $dh=opendir($directory);
  while (false !== ($filename = readdir($dh))) {
    if (is_file($directory."/".$filename)) {
      if (substr($filename,0,1) != ".") {
        if (substr($filename,-4) == ".jpg") {
          $files[]=$filename;
        }
      }
    }
  }
  return($files);
}

function build_about_page() {
  global $dest_dir;

  $fh=fopen("$dest_dir/about.html","w");
  page_header($fh);
  page_menu($fh);
  if (file_exists("about.txt")) {
    $about_text=file_get_contents("about.txt");
  }
  //$about_text=htmlspecialchars($about_text,ENT_QUOTES);
  $about_text='<div id="colophon">'."\n".$about_text."\n</div>\n";
  #$about_text=preg_replace("/\n([^<\n]*)\n/","<p>$1</p>\n",$about_text);
  $about_text=preg_replace("/\n\n/","<br /><br />\n",$about_text);
  fputs($fh,$about_text);
  page_footer($fh,FALSE);
  fclose($fh);
}

function thumb_size($image) {
  if (strlen($image['class']) > 0) {
    $answer='width="'.(int)(($image['width']/$image['height'])*50).'" ';
    $answer.='height="50"';
  } else {
    $answer='width="66" ';
    $answer.='height="'.(int)(($image['height']/$image['width'])*66).'"';
  }
  return($answer);
}

// take an image, use the EXIF/today's date and build a permalink path
// moving the file at the end of it all
function build_permalink($filename,$use_exif=FALSE) {
  global $dest_dir;

  $exif=exif_read_data($filename,'ANY_TAG',TRUE);
  if (is_array($exif) && array_key_exists('COMPUTED',$exif)) {
    if ($exif['COMPUTED']['Height'] > $exif['COMPUTED']['Width']) {
      $portrait=TRUE;
      $computed=($exif['COMPUTED']['Height']/$exif['COMPUTED']['Width'])*50;
    } else {
      $portrait=FALSE;
      $computed=($exif['COMPUTED']['Width']/$exif['COMPUTED']['Height'])*66;
    }
  } else {
    $use_exif=FALSE;
    $portrait=FALSE;
    $computed=44;
  } 
  if ($use_exif) {
    $path=date("Y/m/d",strtotime($exif['IFD0']['DateTime']));
  } else {
    $path=date("Y/m/d");
  }
  $path=$dest_dir."/".$path;
  // next line is PHP5 only :(
  //mkdir($path,0755,TRUE);
  $prev_dir="";
  foreach (explode("/",$path) as $one_dir) {
    @mkdir($prev_dir.$one_dir,0755);
    $prev_dir=$prev_dir.$one_dir."/";
  }
  $prefix="000";
  while (glob($path."/".$prefix."_*")) {
    $prefix+=1;
    $prefix=sprintf("%03d",$prefix);
  }
  $new_filename=$prefix."_".basename($filename);
  if ($portrait) {
    system("convert -resize 465x700 \"$filename\" \"$path/$new_filename\"");
    system("convert -resize ".$computed."x50 \"$path/$new_filename\" \"$path/thumb_$new_filename\"");
  } else {
    system("convert -resize 700x465 \"$filename\" \"$path/$new_filename\"");
    system("convert -resize 66x$computed \"$path/$new_filename\" \"$path/thumb_$new_filename\"");
  }
  system("jpegoptim -q \"$path/thumb_$new_filename\"");
}

function build_rss_feed() {
  global $reverse_files_and_paths,$most_recent_images,$most_recent_five;
  global $site_name,$site_tag,$site_url,$photographer,$dest_dir;

  $rss=new UniversalFeedCreator();
  $rss->title=$site_name;
  $rss->descriptionHtmlSyndicated=TRUE;
  $rss->description=$site_tag;
  $rss->link=$site_url;
  $rss->syndicationURL=$site_url."/feed2.rss";

  foreach ($most_recent_images as $this_entry) {
    $item=new FeedItem();
    $item->title=substr($this_entry['path'],0,4)." :: ".substr($this_entry['path'],5,2)." :: ".substr($this_entry['path'],8,2)." :: ".substr($this_entry['file'],0,3);
    $item->link=$site_url."/".$this_entry['path']."/".basename($this_entry['file'],".jpg").".html";
    $item->descriptionHtmlSyndicated=TRUE;

    $size=getimagesize($dest_dir."/".$this_entry['path']."/".$this_entry['file'],$info);        
    if (is_array($info)) {
      $iptc=iptcparse($info["APP13"]);
      if (is_array($iptc)) {
        $iptc_caption="<p>".htmlspecialchars($iptc["2#120"][0],ENT_QUOTES)."</p>";
      } else {
        $iptc_caption="";
      }
    }
    $item->description=$iptc_caption."<img src=\"".$site_url."/".$this_entry['path']."/".$this_entry['file']."\" ".$this_entry['html']." />";
    $item->author=$photographer;

    $rss->addItem($item);
  }
  // RSS0.91 doesn't like CDATA for passthrough HTML encoding...
  $rss->saveFeed("RSS0.91","$dest_dir/rss.xml",FALSE);
  $rss->saveFeed("RSS2.0","$dest_dir/rss2.xml",FALSE);
}

function generate_permalink_index($image_ref) {
  global $files_and_paths,$dest_dir;

  $prev_file=$image_ref-1;
  $next_file=$image_ref+1;
  $exif=exif_read_data($dest_dir."/".$files_and_paths[$image_ref]['path'].'/'.$files_and_paths[$image_ref]['file'],'ANY_TAG',TRUE);
  $size=getimagesize($dest_dir."/".$files_and_paths[$image_ref]['path']."/".$files_and_paths[$image_ref]['file'],$info);        
  if (is_array($info)) {
    $iptc=iptcparse($info["APP13"]);
    if (is_array($iptc)) {
      $iptc_subloc=htmlspecialchars($iptc["2#092"][0],ENT_QUOTES); 
      $iptc_city=htmlspecialchars($iptc["2#090"][0],ENT_QUOTES);
      $iptc_county=htmlspecialchars($iptc["2#095"][0],ENT_QUOTES); 
      $iptc_country=htmlspecialchars($iptc["2#101"][0],ENT_QUOTES);
      $iptc_source=htmlspecialchars($iptc["2#110"][0],ENT_QUOTES);
      $iptc_copyright=htmlspecialchars($iptc["2#116"][0],ENT_QUOTES); 
      $iptc_caption=htmlspecialchars($iptc["2#120"][0],ENT_QUOTES);
    }
  }
  $aperture_str=explode("/",$exif['EXIF']['FNumber']);
  $aperture=sprintf("%1.1f",$aperture_str[0]/$aperture_str[1]);
  $flength_str=explode("/",$exif['EXIF']['FocalLength']);
  $flength=sprintf("%d",$flength_str[0]/$flength_str[1]);
  $exif_info_block ="'";
  $exif_info_block.="Shutter speed: ".$exif['EXIF']['ExposureTime']."<br />";
  $exif_info_block.="Aperture: f/$aperture<br />";
  $exif_info_block.="Focal length: $flength"."mm<br />";
  $exif_info_block.="ISO: ".$exif['EXIF']['ISOSpeedRatings']."<br />";
  $exif_info_block.="Date: ".$exif['EXIF']['DateTimeOriginal']."<br />";
  $exif_info_block.="Camera: ".$exif['IFD0']['Model']."<br /><br />";
  if ((strlen($iptc_subloc) > 0) && (strlen($iptc_city) > 0)) {
    $exif_info_block.="City: $iptc_subloc, $iptc_city<br />";
  } else {
    if (strlen($iptc_city) > 0)    $exif_info_block.="City: $iptc_city<br />";
  }
  if (strlen($iptc_county) > 0)    $exif_info_block.="County: $iptc_county<br />";
  if (strlen($iptc_country) > 0)   $exif_info_block.="Country: $iptc_country<br />";
  if (strlen($iptc_copyright) > 0) $exif_info_block.="Copyright: $iptc_copyright<br />";
  $exif_info_block.="'";
  $permalink=$files_and_paths[$image_ref]['path']."/".basename($files_and_paths[$image_ref]['file'],".jpg").".html";
  $fh=fopen($dest_dir."/".$permalink,"w");
  page_header($fh);
  page_menu($fh);
  fwrite($fh,'<div id="main">'."\n");
  fwrite($fh,'<div id="photo">'."\n");
  if ($prev_file >= 0) {
    fwrite($fh,'<a href="/'.$files_and_paths[$prev_file]['path'].'/'.basename($files_and_paths[$prev_file]['file'],".jpg").'.html" id="photo-arrow-left" onmouseover="return escape('.$exif_info_block.')"></a>'."\n");
  }
  if ($next_file < count($files_and_paths)) {
    fwrite($fh,'<a href="/'.$files_and_paths[$next_file]['path'].'/'.basename($files_and_paths[$next_file]['file'],".jpg").'.html" id="photo-arrow-right" onmouseover="return escape('.$exif_info_block.')"></a>'."\n");
  }
  fwrite($fh,'<img src="/'.$files_and_paths[$image_ref]['path'].'/'.$files_and_paths[$image_ref]['file'].'" alt="" onmouseover="return escape('.$exif_info_block.')" '.$files_and_paths[$image_ref]['html'].' '.$files_and_paths[$image_ref]['class']." />\n");
  $title=preg_replace("/\//"," :: ",$files_and_paths[$image_ref]['path'])." :: ".substr($files_and_paths[$image_ref]['file'],0,3)." ";
  if (strlen($iptc_caption) == 0) $iptc_caption="(No comment)";
  fwrite($fh,"</div>\n");
  fwrite($fh,'<div id="caption">'."\n");
  fwrite($fh,'<div id="caption-title">'.$title.' <a href="/'.$permalink.'">Permanent Link</a></div>'."\n");
  fwrite($fh,$iptc_caption."\n");
  fwrite($fh,"</div>\n");
  fwrite($fh,'<div id="previous-photos">'."\n");
  if (($image_ref-3) >= 0) {
    fwrite($fh,'<a href="/'.$files_and_paths[($image_ref-3)]['path'].'/'.basename($files_and_paths[($image_ref-3)]['file'],".jpg").'.html" id="arrow-left"></a>'."\n");
  } else {
    fwrite($fh,'<div id="arrow-left-blank"></div>'."\n");
  }
  for ($i=($image_ref-2); $i<=($image_ref+2); $i++) {
    switch ($i) {
      case -2:
        fwrite($fh,'<div class="spacer"></div>'."\n");
        break;
      case -1:
        fwrite($fh,'<div class="spacer"></div>'."\n");
        break;
      case (count($files_and_paths)):
        fwrite($fh,'<div class="spacer"></div>'."\n");
        break;
      case (count($files_and_paths)+1):
        fwrite($fh,'<div class="spacer"></div>'."\n");
        break;
      default:
        fwrite($fh,'<a href="/'.$files_and_paths[$i]['path'].'/'.basename($files_and_paths[$i]['file'],".jpg").'.html"><img src="/'.$files_and_paths[$i]['path'].'/thumb_'.$files_and_paths[$i]['file'].'" '.thumb_size($files_and_paths[$i]).' '.$files_and_paths[$i]['class'].' alt="" /></a>'."\n");
        break;
    }
  }
  if (($image_ref+3) < count($files_and_paths)) {
    fwrite($fh,'<a href="/'.$files_and_paths[($image_ref+3)]['path'].'/'.basename($files_and_paths[($image_ref+3)]['file'],".jpg").'.html" id="arrow-right"></a>'."\n");
  } else {
    fwrite($fh,'<div id="arrow-right-blank"></div>'."\n");
  }
  fwrite($fh,"</div>\n");
  fwrite($fh,"</div>\n");
  page_footer($fh);
  fclose($fh);
  if (substr($files_and_paths[$image_ref]['file'],0,4) == "000_") {
    copy($dest_dir."/".$permalink,$dest_dir."/".$files_and_paths[$image_ref]['path']."/index.html");
  }
}

// look at what's already there, and build data structures that will enable
// quick and easy HTML generation for all pertinant static pages later on
function crawl_existing_files() {
  global $most_recent_images,$most_recent_five,$files_and_paths;
  global $reverse_files_and_paths,$file_tree,$most_recent_count;
  global $dest_dir;

  // we don't want $dest_dir to prefix the results...
  exec("cd $dest_dir ; find . -name '???_*.jpg' -regex '\.\/[0-9].*'",&$files);
  for ($i=0; $i<count($files); $i++) {
    $files[$i]=preg_replace("/[^0-9]+(.*)/","$1",$files[$i]);
  }

  $i=0;
  foreach ($files as $one_file) {
    $all_answers=explode("/",$one_file);
    $file_tree[$all_answers[0]][$all_answers[1]][$all_answers[2]][]=$all_answers[3];
    $files_and_paths[$i]['path']=$all_answers[0]."/".$all_answers[1]."/".$all_answers[2];
    $files_and_paths[$i]['file']=$all_answers[3];
    $finfo=getimagesize($dest_dir."/".$one_file);
    $files_and_paths[$i]['width']=$finfo[0];
    $files_and_paths[$i]['height']=$finfo[1];
    $files_and_paths[$i]['html']=$finfo[3];
    if ($finfo[0] > $finfo[1]) {
      $files_and_paths[$i]['class']="";
    } else {
      $files_and_paths[$i]['class']='class="vert"';
    }
    $i++;
  }

  $reverse_files_and_paths=array_reverse($files_and_paths);
  $max_count=count($files_and_paths);
  if ($max_count > $most_recent_count) $max_count=$most_recent_count;
  for ($i=0; $i<$max_count; $i++) {
    $most_recent_images[]=$reverse_files_and_paths[$i];
  }
  if ($max_count > 5) $max_count=5;
  for ($i=0; $i<$max_count; $i++) {
    $most_recent_five[]=$reverse_files_and_paths[$i];
  }
}

// just take one at a time, so allow full cron control over posting rate
function add_new_file() {
  global $src_dir;

  $ret=0;
  $full_list=get_current_files($src_dir);
  if (count($full_list) > 0) {
    $filename=$full_list[array_rand($full_list)];
    build_permalink($src_dir."/".$filename);
    unlink($src_dir.'/'.$filename);
    $ret=1;
  }
  return($ret);
}

/***********/
/*  MAIN   */
/***********/

// only do something if there was a file to work with
if (add_new_file() > 0) {
  // find out where evrything now lives
  crawl_existing_files();
 
  // globals.  yuk.
  for ($i=0; $i<count($files_and_paths); $i++) {
    generate_permalink_index($i);
  }
  $fh=fopen("$dest_dir/archive.html","w");
  page_header($fh);
  page_menu($fh);
  build_main_archive($fh);
  page_footer($fh,FALSE);
  fclose($fh);
  foreach ($file_tree as $years => $months) {
    $fh=fopen("$dest_dir/$years/index.html","w");
    page_header($fh);
    page_menu($fh);
    build_year_archive($fh,$years);
    page_footer($fh,FALSE);
    fclose($fh);
    foreach ($months as $single_month => $the_days) {
      $fh=fopen("$dest_dir/$years/$single_month/index.html","w");
      page_header($fh);
      page_menu($fh);
      build_month_archive($fh,$years,$single_month);
      page_footer($fh,FALSE);
      fclose($fh);
      foreach ($the_days as $one_day => $all_day_images) {
        $fh=fopen("$dest_dir/$years/$single_month/$one_day/index.html","w");
        page_header($fh);
        page_menu($fh);
        build_day_archive($fh,$years,$single_month,$one_day);
        page_footer($fh,FALSE);
        fclose($fh);
      }
    }
  }
  copy($dest_dir."/".$reverse_files_and_paths[0]['path']."/".basename($reverse_files_and_paths[0]['file'],".jpg").".html","$dest_dir/index.html");
  build_about_page();
  build_rss_feed();
}
?>
